#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <highgui.h>

int get_img_target(char *str, int width, int height, int camera_num, int uvc_cap){

  if(uvc_cap == 1){

     // uvccapture による画像の取得
        int cap;
        char command[100];
        char *cam_dev;

	if(camera_num == 0) cam_dev = "/dev/video0"; 
	if(camera_num == 1) cam_dev = "/dev/video1"; 
	if(camera_num == 2) cam_dev = "/dev/video2"; 
	if(camera_num == 3) cam_dev = "/dev/video3"; 

	//Braightness, Contrast, Saturation, Gain の調性を行う場合
        sprintf(command,"uvccapture -m -d%s -o%s -x%d -y%d -q100 -B-3 -C14 -S50 -G14\n",cam_dev,str,width,height);
	//Braightness, Contrast, Saturation, Gain の調性を行はない場合
        //sprintf(command,"uvccapture -m -d%s -o%s -x%d -y%d \n",cam_dev,str,width,height);

        cap=system(command);
        //usleep(10*1000);
        if(cap!=0){
                printf("Capture fail!!\n");
                return -1;
        }

   }else{

	//double w = 320, h = 240;
 	double w = (double)width, h = (double)height;

	// カメラからのビデオキャプチャを初期化する
	CvCapture *videoCapture = cvCreateCameraCapture( camera_num );
	if( videoCapture == NULL )
	{ 
		return -1;
	}

	// キャプチャサイズを設定する．
	cvSetCaptureProperty (videoCapture, CV_CAP_PROP_FRAME_WIDTH, w);
	cvSetCaptureProperty (videoCapture, CV_CAP_PROP_FRAME_HEIGHT, h);

	// カメラから1フレーム取得する
	IplImage *image = cvQueryFrame (videoCapture);
  	// 画像を保存する
  	cvSaveImage(str, image, 0);

  	// ビデオキャプチャを解放する
  	cvReleaseCapture (&videoCapture);

	/*
  	// ウィンドウを作成する
  	char windowName[] = "camera";
  	cvNamedWindow( windowName, CV_WINDOW_AUTOSIZE );
  	//image = cvQueryFrame (videoCapture);
  	// ウィンドウに画像を表示する
  	cvShowImage( windowName, image );
  	cvWaitKey( 300 ) ;
  	// ウィンドウを破棄する
  	cvDestroyWindow( windowName );
	*/
  }

  //printf("get_img end \n");
  return 0;

}

