#include <stdio.h>
#include <cv.h>
#include <highgui.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
//#include "header/define.h"
#include "image_circle.h"

extern void cv_ColorExtraction(IplImage* src_img, IplImage* dst_img, int code, int ch1_lower, int ch1_upper, int ch2_lower, int ch2_upper, int ch3_lower, int ch3_upper); 
extern int get_img_target(char *, int, int, int, int);

static pthread_t task_id;
static int camera_num, use_uvc;
//static float *p;
static  CvSeq *circles = 0;
static int cycle_time = 1 ;//実行周期[sec]
static int xa, ya, rad;

void image_circle_set(int cam_num, int use_uvccap, int c_time){
  camera_num = cam_num;
  use_uvc = use_uvccap;
  cycle_time = c_time;
}

int circleDetect()
//static void *circleDetect(void *abc)
//static int *circleDetect(void *abc)
{
  int caperr = 0;
  int i;
  float *p;
  IplImage *src_img = 0, *src_img_gray = 0, *src_img_org = 0;
  IplImage *img_hsv = 0 ;
  IplImage *img_ch1 , *img_ch2, *img_ch3 ;
  CvMemStorage *storage;
  //CvSeq *circles = 0;

  //printf("mark1 *****************\n");


//*****画像取得*****

    //int use_uvc = 1; // 0のときは cvQuerryFrame, 1のときは uvccapture を使用する
    caperr = get_img_target("./img/input.jpg", IMG_CIR_X, IMG_CIR_Y, camera_num, use_uvc);
    if(caperr != 0){         //キャプチャが失敗したときの例外処理
            return -1;
    }
    //input = cvLoadImage("./img/input.jpg", CV_LOAD_IMAGE_ANYCOLOR);

   //printf("captured !!!\n");
    src_img_org = cvLoadImage("./img/input.jpg", CV_LOAD_IMAGE_ANYCOLOR);
    src_img = cvLoadImage("./img/input.jpg", CV_LOAD_IMAGE_ANYCOLOR);
   //printf("loaded !!!\n");

  #ifdef __IMAGE_FULL_DEBUG__
  // 画像を表示する
  cvNamedWindow ("pict", 1);
  cvShowImage ("pict", src_img_org);
  cvWaitKey (0);
  #endif

  img_hsv = cvCreateImage(cvGetSize(src_img_org), IPL_DEPTH_8U, 3);
  src_img_gray = cvCreateImage(cvGetSize(src_img_org), IPL_DEPTH_8U, 1);

 // ch1: Hue,  ch2: Saturation,   ch3: Brightness
 int ch1_lower = 0;
 int ch1_upper = 5; //10, 25;
 int ch2_lower = 0;
 int ch2_upper = 255;
 int ch3_lower = 0;
 int ch3_upper = 255;

 // HSVに変換して色抽出をする
  cv_ColorExtraction(src_img_org, src_img_gray, CV_BGR2HSV, ch1_lower, ch1_upper, ch2_lower, ch2_upper, ch3_lower, ch3_upper) ;


  #ifdef __IMAGE_FULL_DEBUG__
  // 画像を表示する
  cvNamedWindow ("gray", 1);
  cvShowImage ("gray", src_img_gray);
  cvWaitKey (0);
  #endif

  // (2)ハフ変換のための前処理（画像の平滑化を行なわないと誤検出が発生しやすい）
  cvSmooth (src_img_gray, src_img_gray, CV_GAUSSIAN, 11, 11, 0, 0);

  #ifdef __IMAGE_FULL_DEBUG__
  // 画像を表示する
  cvNamedWindow ("pict", 1);
  cvShowImage ("pict", src_img_gray);
  cvWaitKey (0);
  #endif

  storage = cvCreateMemStorage (0);

  // (3)ハフ変換による円の検出と検出した円の描画

  int dp = 1 ; //円の中心を求める際に用いられる計算時の解像度．例えば，この値が 1 の場合は，計算は入力画像と同じ解像度で行われる．2 の場合は，計算は幅・高さともに1/2の解像度になる
  int min_dist = 50; //100; //円検出における中心座標間の最小間隔．この値が非常に小さい場合は，正しく抽出されるべき円の近傍に複数の間違った円が検出されることになる．また，逆に非常に大きい場合は，円検出に失敗する
  int parm1 = 20; // 10, 20, 40; //Cannyのエッジ検出器で用いる二つの閾値の高い方の値 (低い方の値は，この値を1/2したものになる）
  int parm2 = 40; //50; //中心検出計算時の閾値．小さすぎると誤検出が多くなる．これに対応する値が大きい円から順に検出される．
  int min_radius = 3; //2, 10; //検出すべき円の最小半径
  int max_radius = MAX (src_img_gray->width, src_img_gray->height); //検出すべき円の最大半径
  // parm2 の値に敏感
  //circles = cvHoughCircles (src_img_gray, storage, CV_HOUGH_GRADIENT,
  //                          1, 100, 20, 50, 10, MAX (src_img_gray->width, src_img_gray->height));
  circles = cvHoughCircles (src_img_gray, storage, CV_HOUGH_GRADIENT,
                            dp, min_dist, parm1, parm2, min_radius, max_radius);

  if(circles->total>0){
  //for (i = 0; i < circles->total; i++) {
    for (i = 0; i < 1 ; i++) {
      p = (float *) cvGetSeqElem (circles, i);
      cvCircle (src_img, cvPoint (cvRound (p[0]), cvRound (p[1])), 3, CV_RGB (0, 255, 0), -1, 8, 0);
      cvCircle (src_img, cvPoint (cvRound (p[0]), cvRound (p[1])), cvRound (p[2]), CV_RGB (255, 0, 0), 3, 8, 0);
      //cvCircle (src_img_org, cvPoint (cvRound (p[0]), cvRound (p[1])), 3, CV_RGB (0, 255, 0), -1, 8, 0);
      //cvCircle (src_img_org, cvPoint (cvRound (p[0]), cvRound (p[1])), cvRound (p[2]), CV_RGB (255, 0, 0), 3, 8, 0);
    }
  }

  #ifdef __IMAGE_DEBUG__
  // 検出結果表示用のウィンドウを確保し表示する
  cvNamedWindow ("circles", 1);
  cvShowImage ("circles", src_img);
  cvWaitKey (500); // 0.5秒表示
  #endif

  cvDestroyWindow ("circles");
  cvReleaseImage (&src_img);
  cvReleaseImage (&src_img_org);
  cvReleaseImage (&src_img_gray);
  cvReleaseMemStorage (&storage);

  if( circles->total> 0 ){
    xa =  cvRound(p[0]);
    ya =  cvRound(p[1]);
    rad =  cvRound(p[2]);
    #ifdef __IMAGE_DEBUG__
       printf( "x=%d, y=%d,  r=%d \n", xa, ya, rad);
    #endif
  }else{
    xa = -1; ya = -1; rad = -1;
  }

  return 0;

}

void  image_circle_get_position(int *x_axis, int *y_axis, int *radius){

   *x_axis = xa; *y_axis = ya; *radius = rad;

}

static void *thread_code(){

	int ret_val;

	while(1){
		ret_val = circleDetect();
		//sleep(cycle_time);
		usleep(cycle_time*1000);
	}

}

void image_circle_create(){

        pthread_attr_t attr;
        struct sched_param sched_param;
        int ret;
        int policy;

        pthread_attr_init(&attr);
        ret = pthread_create(&task_id, &attr, thread_code, NULL);

        pthread_getschedparam(pthread_self(), &policy, &sched_param);
        printf("plicy = %s, priority =%d\n",
                (policy == SCHED_FIFO)  ? "SCHED_FIFO" :
                (policy == SCHED_RR)    ? "SCHED_RR" :
                (policy == SCHED_OTHER) ? "SCHED_OTHER" :
                "???",
                sched_param.sched_priority);

}


void image_circle_cancel(){

        pthread_cancel(task_id);

}

