//全体の制御を行う
//main
#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

#include "mirsak.h"
#include "number.h"
#include "serial_cpu.h"
#include "comm.h"

int main(void){
	int fd;
	uint8_t cat_data = 0;
	char ret_data[2] = {0, 0};
	int numbers[2];
	int count = 0;
	// 数字認識距離
	int num_distance = 50;
	// 送信データ
	char file[100] = "number1.data";

	int ret_val;
	
	number_set_nums(1);

	// シリアル系初期化
	fd = serial_cpu_init();
	// オープン失敗でプログラム終了
	printf("device : %d\n", fd);
	if(fd < 0){
		perror("デバイスファイルのオープンに失敗");
		exit(1);
	}
	
	printf("mirs main program: start command?\nr : right start \nl : left start\ne : chase east start\nw : chase west start\n:");
	ret_data[0] = 'c';
	ret_val = scanf("%c",&ret_data[1]);
	printf("command : %c",ret_data[1]);
	serial_cpu_write(fd, ret_data);

	
	while(1){
		// データ受信
		cat_data = serial_cpu_read(fd);
		printf("received data: %x\n", cat_data);
		// 受信データがあれば
		if(cat_data > 0){
			switch(cat_data){
				case 0xA0:	// 数字認識
					count = 0;
					ret_data[0] = 'n';
					printf("num mode selected: ");
					// カメラ番号受信
					cat_data = serial_cpu_read(fd);
					printf("cam_no = %d\n", cat_data);
					while(1){
						ret_val = number_detect(((cat_data == 1)?num_distance - 25 : num_distance), cat_data);
						number_get(numbers);
						printf("数字: %d\n", numbers[0]);
						if(numbers[0] != -1){
							ret_data[1] = (char)numbers[0];
							break;
						}
						else{
							count++;
						}
						if(count > 4){
							break;
						}
					}
					serial_cpu_write(fd, ret_data);
					comm_put_number(numbers[0], file);
					break;

				case 0xA1:	// 赤色認識
					ret_data[0] = 'b';
					serial_cpu_write(fd, ret_data);
					break;
				default:
					printf("Error: not command");
					break;
			}
		}
		usleep(1000*10);	// 10ms
	}

	return 0;
}

