#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <termios.h>
#include <time.h>

#include "serial_cpu.h"

int serial_cpu_init(void){
	int fd;
	fd = open(DEV_NAME, O_RDWR);
	if(fd < 0){
		return -1;
	}
	struct termios tio;
	memset(&tio, 0, sizeof(tio));
	tio.c_cflag = CS8 | CLOCAL | CREAD;
	tio.c_cc[VTIME] = 100;
	tio.c_cc[VMIN]  = 1;	// 1文字来るまで読み込みをブロック
	// ボーレートの設定
	cfsetispeed(&tio, BAUD_RATE);
	cfsetospeed(&tio, BAUD_RATE);
	// デバイスに設定を行う
	tcsetattr(fd, TCSANOW, &tio);
	return fd;
}

uint8_t serial_cpu_read(int fd){
	uint8_t cat_data;
	int ret;
	ret = read(fd, (char *)&cat_data, 1);
	return cat_data;
}

// メイン
int serial_cpu_write(int fd, char *ret_data){
	int ret;
	ret = write(fd, &ret_data[0], 1);	// 先頭識別データ (0xA0:数字認識, 0xA1:赤色認識)
	ret = write(fd, &ret_data[1], 1);
	return 0;
}
