#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "image_circle.h"

int test_image_circle(){

	int max_loop = 10; // 最大ループ数
	int count = 0;
	int cam_num= 0; //カメラ番号（１台目が 0）
	int use_uvccap = 1; //1: uvccapture を使用する、0：使用しない
	int wait_mtime = 100; //画像処理の休止時間 [msec]
	int ret_val = 0;
	int x_axis, y_axis, radius;

	printf("風船認識テストプログラムスタート！\n");

	//カメラを複数取り付けている場合、次の２行をコメントアウトをはずす
	//printf("カメラ番号（１台目：0、２台目:1、....）= ");
	//ret_val = scanf("%d",&cam_num);

	// カメラ番号、画像取得方法等を指定
	image_circle_set(cam_num, use_uvccap, wait_mtime);
	//printf("set complete!");

	// 画像処理スレッドの生成
	image_circle_create();
	//printf("create complete!");

	while(1){

		//風船の中心座標と半径を取得する
		image_circle_get_position(&x_axis, &y_axis, &radius);
		if( radius > 0){
			printf( "count =%d    x_axis=%d, y_axis=%d,  radius=%d \n", count, x_axis, y_axis, radius);
		}else{
			printf( "count =%d    red circle not detectedd !!\n", count);
		}

		if(count > max_loop){
			break;
		}

		//printf("メイン一周終了\n");
		usleep(1*1000*1000); //一秒待つ
		count++;

	}

	printf("メインwhileの終了\n");
	image_circle_cancel();

	return 0;
}

//単独で試験する場合は以下のコメントアウトをはずす
/*
int main(){

	test_image_circle();

}
*/
